#ifndef LCD_H_
#define LCD_H_

#define USE_LCD_LOCATE	1			// ustawia kursor na wybranej pozycji Y,X (Y=0-3, X=0-n)
#define USE_LCD_CHAR 	0			// wysya pojedynczy znak jako argument funkcji
#define USE_LCD_STR_P 	0			// wysya string umieszczony w pamici FLASH
#define USE_LCD_INT 	1			// wywietla liczb dziesietn na LCD
#define USE_LCD_CURSOR_ON 		1	// obsuga wczania/wyczania kursora
#define USE_LCD_CURSOR_BLINK 	1	// obsuga wczania/wyczania migania kursora
#define USE_LCD_CURSOR_HOME 	1	// ustawia kursor na pozycji pocztkowej


/*#define PORT(x) SPORT(x)
#define SPORT(x) (PORT##x )   //##  sklejanie
#define PIN(x) SPIN(x)
#define SPIN(x) (PIN##x )
#define DDR(x) SDDR(x)
#define SDDR(x) (DDR##x )*/


#define PORT(x) SPORT(x)
#define SPORT(x) (PORT##x )   //##  sklejanie
#define PIN(x) SPIN(x)
#define SPIN(x) (PIN##x )
#define DDR(x) SDDR(x)
#define SDDR(x) (DDR##x )

#define LCD_D7PORT A
#define LCD_D7 3
#define LCD_D6PORT A
#define LCD_D6 6
#define LCD_D5PORT A
#define LCD_D5 5
#define LCD_D4PORT A
#define LCD_D4 4
#define LCD_RSPORT B
#define LCD_RS 7
#define LCD_EPORT B
#define LCD_E 6

#define CLR_E PORT(LCD_EPORT) &= ~(1<<LCD_E)


#if ( (LCD_Y == 4) && (LCD_X == 20))	//rozne rozmiary wyswietlacza
#define LCD_LINE1 0x00
#define LCD_LINE2 0x28
#define LCD_LINE3 0x14
#define LCD_LINE4 0x54
#else
#define LCD_LINE1 0x00
#define LCD_LINE2 0x40
#define LCD_LINE3 0x10
#define LCD_LINE4 0x50
#endif

//fajne makra
#define SET_RS PORT(LCD_RSPORT) |= (1<<LCD_RS)
#define CLR_RS PORT(LCD_RSPORT) &= ~(1<<LCD_RS)

#define SET_E PORT(LCD_EPORT) |= (1<<LCD_E)
#define CLR_E PORT(LCD_EPORT) &= ~(1<<LCD_E)


//funkcje bo po co to pamietac
#define LCDC_CLS					0x01
#define LCDC_HOME					0x02
#define LCDC_ENTRY					0x04
#define LCDC_ENTRYR					0x02
#define LCDC_ENTRYL					0
#define LCDC_MOVE					0x01
#define LCDC_ONOFF					0x08
#define LCDC_DISPLAYON				0x04
#define LCDC_CURSORON				0x02
#define LCDC_CURSOROFF				0
#define LCDC_BLINKON				0x01
#define LCDC_SHIFT					0x10
#define LCDC_SHIFTDISP				0x08
#define LCDC_SHIFTR					0x04
#define LCDC_SHIFTL					0
#define LCDC_FUNC					0x20
#define LCDC_FUNC8B					0x10
#define LCDC_FUNC4B					0
#define LCDC_FUNC2L					0x08
#define LCDC_FUNC1L					0
#define LCDC_FUNC5x10				0x04
#define LCDC_FUNC5x7				0
#define LCDC_SET_CGRAM				0x40
#define LCDC_SET_DDRAM				0x80




void lcd_init(void);
void lcd_cls(void);
void lcd_str(char * str);
void data_dir_in(void);
void data_dir_out(void);
static inline void lcd_sendHalf(uint8_t data);	//wysyla dane do wyswietlacza
void _lcd_write_byte(unsigned char _data);
void lcd_write_cmd(uint8_t cmd);
void lcd_write_data(uint8_t data);

void lcd_home(void);
void lcd_blink_off(void);
void lcd_blink_on(void);
void lcd_cursor_off(void);
void lcd_cursor_on(void);
void lcd_home(void);
void lcd_locate(uint8_t y, uint8_t x);

void lcd_str_P(char * str);

#endif /* LCD_H_ */
